<?php

namespace App\Service\SnipParser;

use App\Service\SnipParser\Stages\HtmlEscapeStage;
use App\Service\SnipParser\Stages\ReplaceBlocksStage;
use League\Pipeline\PipelineBuilder;

class Pipeline
{
    public function parse(string $payload): string
    {
        $builder = new PipelineBuilder();
        $pipeline = $builder
            ->add(new HtmlEscapeStage())
            ->add(new ReplaceBlocksStage('<pre><code class="hljs">', '</code></pre>', '```'))
            ->add(new ReplaceBlocksStage('<code class="hljs">', '</code>', '``'))
            ->build();

        return $pipeline->process($payload);
    }
}